import java.util.*;
public class StringFormatter
{
    /** Returns a formatted string consisting of the words in wordList separated by spaces.
     * Precondition: ThewordListcontainsatleasttwowords,consistingoflettersonly. formattedLen is large enough for all the words and gaps.
     * Postcondition: All words in wordList appear in the formatted string.
     * - The words appear in the same order as in wordList.
     * - The number of spaces between words is determined by basicGapWidth and the
     * distribution of leftoverSpaces from left to right, as described in the question. 
    **/
    public static String format(ArrayList<String> wordList, int formattedLen)
    {
         //Implement part c here
    }
    /**
     * Returns the basic gap width when wordList is used to produce
     * a formatted string of formattedLen characters.
     * Precondition: wordList contains at least two words, consisting of letters only. 
     * formattedLen is large enough for all the words and gaps.
    **/
    public static int basicGapWidth(ArrayList<String> wordList, int formattedLen)
    {
        //Copy your solution from part b here
    }
    
    public static int totalLetters(ArrayList<String> wordList)
    {
        //Copy your solution from part a here
    }
    
    /** Returns the number of leftover spaces when wordList is used to produce
    * a formatted string of formattedLen characters.
    * Precondition: wordList contains at least two words, consisting of letters only.
    * formattedLen is large enough for all the words and gaps. 
    Implementation shown for testing purposes
    */
    public static int leftoverSpaces(ArrayList<String> wordList, int formattedLen)
    {
        return formattedLen - (totalLetters(wordList) + (basicGapWidth(wordList, formattedLen) * wordList.size()- 1));
    }
}