import java.util.ArrayList;
public class StringFormatterTester
{
    public static void main(String[] args)
    {
        /********** Tester Class **********
        * This class is for testing only.
        * You do not need to update this
        * file. Complete your work in the
        * StringFormatter.java file
        *********************************/
        
        ArrayList<String> wordList = new ArrayList<String>();
        wordList.add("AP");
        wordList.add("COMP");
        wordList.add("SCI");
        wordList.add("ROCKS");
        System.out.println("Testing Part A:");
        System.out.println("Initializing ArrayList [AP, COMP, SCI, ROCKS]");
        System.out.println("Calling totalLetters. Expected result 14:");
        System.out.println(StringFormatter.totalLetters(wordList));
        
        System.out.println("------------------");
        System.out.println("Testing Part B:");
        System.out.println("Basic gap width for formatted length of 20: (Expected result 2)");
        System.out.println(StringFormatter.basicGapWidth(wordList, 20));
        
        
        System.out.println("------------------");
        System.out.println("Testing Part C:");
        System.out.println("Formatted String with length 20:");
        String result = StringFormatter.format(wordList, 20);
        System.out.println(result);
        indexCount(result);
        
        System.out.println();
        
        
        wordList = new ArrayList<String>();
        wordList.add("BEACH");
        wordList.add("BALL");
        System.out.println("Testing Part A:");
        System.out.println("Initializing ArrayList [BEACH, BALL]");
        System.out.println("Calling totalLetters. Expected result 9:");
        System.out.println(StringFormatter.totalLetters(wordList));
        System.out.println("------------------");
        System.out.println("Testing Part B:");
        System.out.println("Basic gap width for formatted length of 20: (Expected result 11)");
        System.out.println(StringFormatter.basicGapWidth(wordList, 20));
        System.out.println("------------------");
        System.out.println("Testing Part C:");
        result = StringFormatter.format(wordList, 20);
        System.out.println("Formatted String with length 20:");
        System.out.println(result);
        indexCount(result);
        
    }
    
    public static void indexCount(String word)
    {
        for(int i = 0; i < word.length(); i++)
        {
            System.out.println(i + ":" + word.substring(i, i+1));
        }
    }
}
